<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.parser.*" %>
<%@ page import="com.sas.query.visuals.*" %>
<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     userPromptRun.jsp
//
// HISTORY:   Date    Who     Action
//           -------------------------------------------------------
// S0262697  10Aug04  sby     - Added body onLoad() function
//			      - Added disableOnFormload() function
//			      - Changed checkAll() function to disable/enable select elements
//	     19Aug04  akv     - Modified disableOnFormload() and checkAll() functions to handle
//				multiple values in selection list
// NOTES:
//
/*********************************************************************/
%>
<%@ include file="HRVLoginInclude.jsp"%>

<%

OptionBean oB = OptionBean.getInstance(session);
boolean promptselectallOn = false;
boolean promptselectallValueOn = false;
String propmtselectall = oB.getOption("promptselectall");
String propmtselectallValues = (String)hrvi.getConfigValue( "promptselectallvalues" );
if (propmtselectall != null && (propmtselectall.equalsIgnoreCase("yes")||propmtselectall.equalsIgnoreCase("y")))
	promptselectallOn = true;

if (propmtselectallValues != null && (propmtselectallValues.equalsIgnoreCase("yes")||propmtselectallValues.equalsIgnoreCase("y")))
	promptselectallValueOn = true;

%>

<html>
<head>
   <%@ include file="HRVHeadInclude.jsp"%>
   <script language="JavaScript">

   	function disableOnFormload(){
   		if (<%=promptselectallOn%> == true){
   			for(i=0;i<document.forms['userpromptform'].elements.length;i++){
				var elementtype = document.forms['userpromptform'].elements[i].type;
				if (elementtype.indexOf("select") > -1){

				if (elementtype == "select-multiple")
				{
					if (<%=promptselectallValueOn%> == true){
				    	for(j=0;j<document.forms['userpromptform'].elements[i].length;j++)
				    	{
				            document.forms['userpromptform'].elements[i].options[j].selected=true;
				   	 	}
					}
					else{
				    	for(j=0;j<document.forms['userpromptform'].elements[i].length;j++)
				    	{
				    		if(j == 0 || j == 1 || j == 2 || j ==3)
				            	document.forms['userpromptform'].elements[i].options[j].selected=true;
				   	 	}
					}

				}
					document.forms['userpromptform'].elements[i].disabled=true;
   			    }
   			}
   		}
   	}

   	function checkAll(up){
	    var objEl = document.forms['userpromptform'].elements[up];
		if (objEl.disabled == true){
			objEl.disabled=false;

			if (objEl.type == "select-multiple")
			{

				for(i=0;i<objEl.length;i++)
				{
				    objEl.options[i].selected = false;
				}
			}
		}
		else{
			if (objEl.type == "select-multiple")
			{
				if (<%=promptselectallValueOn%> == true){
					for(i=0;i<objEl.length;i++)
					{
			    		objEl.options[i].selected = true;
					}
				}else{
					for(i=0;i<objEl.length;i++)
					{
				    	objEl.options[i].selected = false;
				    	if(i == 0 || i == 1 || i ==2 || i ==3)
				    		objEl.options[i].selected = true;
					}
				}
			}
			objEl.disabled=true;
		}
	}

	function enableAll(){
		for(i=0;i<document.forms['userpromptform'].elements.length;i++){
				var elementtype = document.forms['userpromptform'].elements[i].type;
				if (elementtype.indexOf("select") > -1){
					document.forms['userpromptform'].elements[i].disabled=false;
   			    }
   			}
	}

   </script>
</head>

<%

VisMsg vM = VisMsg.getInstance (session);
String errMsg = request.getParameter ("errMsg");
String returnUrl = (String)session.getAttribute ("returnURL");
String sessionTableName = request.getParameter ("table");
String sessionKey = request.getParameter ("sessionkey");
UserPromptDisplay disp = null;
boolean isUserAdmin = HrvInfo.isUserAdmin(session);
int location = 0;
try {
if (errMsg == null) {
	Vector userPromptVector = (Vector)session.getAttribute ("userPromptVector");
	Vector userPromptLocationVector = (Vector)session.getAttribute ("userPromptLocationVector");
	// get the next item
	String tableKey = (String)userPromptVector.get (0);
	int tableLoc = Integer.parseInt((String)userPromptLocationVector.get (0));

	// now remove it so we don't process it again
	userPromptVector.remove (0);
	userPromptLocationVector.remove (0);

	// reset the vector on the session
	session.setAttribute ("userPromptVector", userPromptVector);
	session.setAttribute ("userPromptLocationVector", userPromptLocationVector);

	String loc = request.getParameter("location");
	if (loc == null) {
		location = TableBean.PUBLIC_LOC;
		if (!isUserAdmin)
			location = TableBean.PRIVATE_LOC;
	}
	else {
		location = Integer.parseInt(loc);
	}

	// create the table bean
	TableBean thisTable = null;
	// if we came from query and this is the last item, then it's
	// the table that Brian gave us.
	if (returnUrl.toUpperCase ().indexOf ("SESSIONKEY") >= 0 &&
		userPromptVector.size () == 0) {
		thisTable = (TableBean)session.getAttribute (sessionTableName);
	} else {
		thisTable = new TableBean (session);
		thisTable.setMetaLocation (tableLoc);
		thisTable.setMetaKey (tableKey);
	}
	session.setAttribute ("currentTable", thisTable);

	disp = new UserPromptDisplay (session, thisTable);
	// add to session object
	session.setAttribute ("userPromptDisplay", disp);
} else {
	disp = (UserPromptDisplay)session.getAttribute ("userPromptDisplay");
}

%>

<body onLoad="javascript:disableOnFormload()">

<%
// do this stuff if we came from the query area.
if (returnUrl.toUpperCase ().indexOf ("SESSIONKEY") >= 0) {
%>

<FORM NAME="initQry" ACTION="userPromptQuery.jsp" METHOD=GET>
<input type=hidden name="intAction" value="">
<input type=hidden name="sessionkey" value="<%= sessionKey %>">
</FORM>
<SCRIPT>
<!--
function doNav(cmd) {
   document.initQry.intAction.value=cmd;
   document.initQry.submit();
}


function processGoto(step) { doNav('goto.'+step); }
//-->
</SCRIPT>

<%
}
%>

<%
if (errMsg != null) {
	disp.setErrorMsg (errMsg);
}
%>

<%
	if (location != 0)
		disp.setHiddenFields("location", Integer.toString(location));
		disp.from = request.getParameter("from");
	out.println (disp.toHtml ());
%>

<%
// do this stuff if we came from the query area.
if (returnUrl.toUpperCase ().indexOf ("SESSIONKEY") >= 0) {
%>
<input type=hidden name="table" value="<%= sessionTableName %>">
<%
}

// if we have a session key then output it
if (sessionKey != null) {
%>
<input type=hidden name="sessionkey" value="<%= sessionKey %>">
<%
}
%>

</form>

<%
} catch (InsufficientSecurityException e) {
%>

<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>
<p class="ERRMSG">

<%=vM.getLabel ("InsufficientSecurityError")%>

<form name="userpromptform" action="userPrompt.jsp">
<input type="submit" class="button" value="<%=vM.getLabel ("OK")%>">
<input type="hidden" name="command" value="ERROR">
<input type="hidden" name="from" value='<%=request.getParameter("from")%>'>
</form>

</p>
</td>
</tr>
</table>

</td></tr>
</table>

<%
} catch (ConnectionErrorException e) {
%>

<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>
<p class="ERRMSG">

<%=vM.getLabel ("ConnectionError")%>

<form name="userpromptform" action="userPrompt.jsp">
<input type="submit" class="button" value="<%=vM.getLabel ("OK")%>">
<input type="hidden" name="command" value="ERROR">
<input type="hidden" name="from" value='<%=request.getParameter("from")%>'>
</form>

</p>
</td>
</tr>
</table>

</td></tr>
</table>

<%
} catch (CalculatedColumnException e) {
%>

<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>
<p class="ERRMSG">

<%=vM.getLabel ("CalculatedColumnError")%>

<form name="userpromptform" action="userPrompt.jsp">
<input type="submit" class="button" value="<%=vM.getLabel ("OK")%>">
<input type="hidden" name="command" value="ERROR">
<input type="hidden" name="from" value='<%=request.getParameter("from")%>'>
</form>

</p>
</td>
</tr>
</table>

</td></tr>
</table>

<%
} catch (Exception e) {
%>

<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>
<p class="ERRMSG">

<%=vM.getLabel ("GenericUserpromptError")%>

<form name="userpromptform" action="userPrompt.jsp">
<input type="submit" class="button" value="<%=vM.getLabel ("OK")%>">
<input type="hidden" name="command" value="ERROR">
<input type="hidden" name="from" value='<%=request.getParameter("from")%>'>
</form>

</p>
</td>
</tr>
</table>

</td></tr>
</table>

<%
}
%>

</body>
</html>