<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>
<%@page import="com.sas.net.server.RemoteSasException" %>
<%@include file="HRVLoginInclude.jsp"%>

<%
/*********************************************************************/
// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     geoIcons.jsp
// AUTHOR:   sassat - Sarah Tacker
// SUPPORT:  sassat - Sarah Tacker
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  jsp to display the icons on the Geographic Analysis.
// 			 Copied from explorerIcon.jsp.
//
// HISTORY:   Date    Who  Action
//           -------------------------------------------------------
//           31may01  sat  initial coding
/*********************************************************************/
%>

<%
	VisMsg vm = VisMsg.getInstance(session);


	String drillSrc = vm.getLink ( "ICON_GEOdrill" );
	String drillSel = vm.getLink ( "ICON_GEOdrillSEL" );
	String drillAlt = vm.getLabel ( "ICON_GEOdrill" );
	String drillSelAlt = vm.getLabel ( "ICON_GEOdrillSEL" );

	String detailSrc = vm.getLink ( "ICON_GEOdetail" );
	String detailSel = vm.getLink ( "ICON_GEOdetailSEL" );
	String detailAlt = vm.getLabel ( "ICON_GEOdetail" );
	String detailSelAlt = vm.getLabel ( "ICON_GEOdetailSEL" );




%>

<HTML><HEAD>
  <%@include file="HRVHeadInclude.jsp"%>

<%
	int icon = 1;
	String[] Src = new String[4];
	String[] Sel = new String[4];
	String[] Alt = new String[4];
	String[] AltSel = new String[4];
	String[] action = new String[4];
%>
  <script language="javaScript">
	if( document.images ) {

<%
		Src[icon] = drillSrc;
		Sel[icon] = drillSel;
		Alt[icon] = drillAlt;
		AltSel[icon] = drillSelAlt;
		action[icon] = "drill";
%>

	 var imgCol<%=icon%>        = new Image();
		  imgCol<%=icon%>.src     = "<%=drillSrc%>";
		  imgCol<%=icon%>.alt     = "<%=drillAlt%>";
	 var imgCol<%=icon%>sel      = new Image();
		  imgCol<%=icon%>sel.src  = "<%=drillSel%>";
		  imgCol<%=icon%>sel.alt  = "<%=drillSelAlt%>";

<%
		icon++;

		Src[icon] = detailSrc;
		Sel[icon] = detailSel;
		Alt[icon] = detailAlt;
		AltSel[icon] = detailSelAlt;
		action[icon] = "detail";
%>

	 var imgCol<%=icon%>        = new Image();
		  imgCol<%=icon%>.src     = "<%=detailSrc%>";
		  imgCol<%=icon%>.alt     = "<%=detailAlt%>";
	 var imgCol<%=icon%>sel      = new Image();
		  imgCol<%=icon%>sel.src  = "<%=detailSel%>";
		  imgCol<%=icon%>sel.alt  = "<%=detailSelAlt%>";

<%
	int totIcons = icon;
	String noLevels = vm.getSentence( "NoLevels" );


%>

	}

	function processClick( baseName, toggleOn, total, cmdField, cmdValue )
	{
		toggle( baseName, toggleOn, total );
		// set command value this frame
		document.clickInfo.elements[cmdField].value = cmdValue;
	}

	function processItemClick (key, nextlevel, slctVar,selection,datasrc,allowdrill,location,loc,
		geoWhere1,geoWhere2,geoWhere3,geoWhere4,geoWhere5)
	{

//alert("in processItemClick");
//alert( "key = "+key+
//"nextLevel = "+nextlevel+
//"slctVar = "+slctVar+
//"selection = "+selection+
//"geoWhere1 = "+geoWhere1);


		var doforward = true;
		var action = document.clickInfo.actionClick.value;
		if (action == "drill")
		{
			if (allowdrill)
			{
				url = 'Jsp/geoc.jsp?key=' + key + '&location=' + location +'&nextLevel=' + nextlevel + '&slctVar=' + slctVar + '&selection=' + selection;
				parent.HRVContent.document.location.href = url;
			/*alert(url);*/
			}
			else alert("<%=noLevels%>");
		}
		else if (action == "detail")
		{
			url = "openTable.jsp"+"?key="+datasrc+"&location="+loc+
			"&ctrlButtons=true&subset=" +geoWhere1 + geoWhere2 + geoWhere3 + geoWhere4 + geoWhere5+ slctVar + "='" + selection+"'";

			url = 'Jsp/newWindow.jsp?' + url;

			/*alert(url);*/
			var x = self.screenLeft + 10;
			var y = self.screenTop + 10;
			var props = 'height=1 width=1 alwaysLowered screenX=' + x + ' screenY=' + y;
			newWin = open(url, 'HrvScratchWindow', props);
		}
	}
  </script>
  <script language="javaScript" src="../Html/icontoggle.js">
  </script>
</HEAD>

<BODY>

<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<tr>
<td valign="center" class="iconbox" align="right">
   <table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr valign="center">
   <td width="4"></td>
	<td>
	   <img id="imgSep1" name="iconSep1" src="../Images/icons/divider.gif">

<%


	String iconDisp, iconAlt, act, specialAct;
	String formVal = "";
	for (icon=1; icon <= totIcons; icon++) {
		iconAlt = Alt[icon];
		act = action[icon];
		specialAct = act.substring(0,1).toUpperCase() + act.substring(1).toLowerCase();
		if (icon == 1) {
			iconDisp = Sel[icon];
			formVal = act;
			iconAlt = AltSel[icon];
		}
		else
			iconDisp = Src[icon];
%>

		<a href="javascript: void 0;" id="iconCol<%=specialAct%>"
		onclick="setTimeout('processClick(\'imgCol\',<%=icon%>,<%=totIcons%>,\'actionClick\',\'<%=act%>\')',1);"><img
			name="imgCol<%=icon%>" id="iconCol<%=specialAct%>" border="0"
			src="<%=iconDisp%>"
			alt="<%=iconAlt%>" onMouseOver="window.status=this.alt;return true;" onMouseOut="window.status='';return true;"</img></a>

<%
	}
%>

	</td>
	</tr>
	</table>
</td>
</tr>
</table>

<form name="clickInfo">
  <input type="hidden" name="actionClick" value="<%=formVal%>">
</form>

</BODY>
</HTML>