<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%
/*********************************************************************/
// Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513
/*********************************************************************/
//
// NAME:     loginPwdChange.jsp
// AUTHOR:   maperr - Matthew Perry
// SUPPORT:  maperr - Matthew Perry
// PRODUCT:  hrvision
// TYPE:     jsp page
// LANGUAGE: java
// PURPOSE:  force the user to change their password if set/reset by admin
//
// HISTORY:   Date    Who     Action
//           -------------------------------------------------------
//           05Feb02  maperr  initial coding
/*********************************************************************/
%>

<%@ include file="HRVLoginInclude.jsp"%>
<html>
<head>
<%@ include file="HRVHeadInclude.jsp"%>
<script language="JavaScript">
	function setCommand(){
		document.PWDCHANGE.command.value = "CHANGE";
	}
</script>
</head>

<%
	UserBean userBean = null;
	VisMsg vM = VisMsg.getInstance(session);
	CodeBean cB = HrvInfo.getCodeBean(session);
	userBean = new UserBean(session);
	
	String currentPrefName = cB.getUserAttributeValue("name");
	String currentEmail = cB.getUserAttributeValue("email");
	
	if(currentEmail == null)
		currentEmail = "";
	if(currentPrefName == null)
		currentPrefName = "";
	
	String oldPwdMsg = vM.getLabel("CPCenterOldPassword");
	String newPwdMsg = vM.getLabel("CPCenterNewPassword");
	String verifyPwdMsg = vM.getLabel("CPCverifyNewPassword");
	String change = vM.getLabel("CPCchangePwd");
	String errorMessage = "<font color=\"white\"> Blank Space </font>";
	String changeMessageFromSysadm = vM.getLabel("changeMessage");
	String prefName = vM.getLabel("UserAttr_name.txt");
	String email = vM.getLabel("UserAttr_email.txt");
	int i = 0;
	
	String browserType = (String)hrvi.getBrowserType(session);
	int borderType = 0;
	if(!browserType.equalsIgnoreCase("IE"))
		borderType = 1;
%> 
<body onload="document.PWDCHANGE.oldPass.focus();" class="bodyContents">
<form name="PWDCHANGE" method="post" action="loginPwdChange.jsp">
<table border="0" width="100%" height="100%"> 
	<tr align="CENTER"><td valign="CENTER">
	<table>
	<tr>
	<td><font color="red"><%=changeMessageFromSysadm%></font><br><br>
	<table class="ENTRYBOX" border="<%=borderType%>"  cellspacing=2 cellpadding=5 width=450 align=center>
			<tr>
				<td ><b><%=prefName%>:</b></td>
				<td align=center><input type="text" name="prefName" value="<%=currentPrefName%>" size=32></td>
			</tr>
			<tr>
				<td ><b><%=email%>:</b></td>
				<td align=center><input type="text" name="email" value="<%=currentEmail%>" size=32></td>
			</tr>
	</table>
		
		
	</td>
	</tr>
	</table>

	<table class="ENTRYBOX" border="<%=borderType%>"  cellspacing=2 cellpadding=5 width=450>
		<tr>
			<td><B><%=oldPwdMsg%></B></td>
			<td><input type="password" name="oldPass" size="32" maxlength="16"></td>
		</tr>
		<tr>
			<td><B><%=newPwdMsg%></B></td>
			<td><input type="password" name="newPass" size="32" maxlength="16"></td>
		</tr>
		<tr>
			<td><B><%=verifyPwdMsg%></B></td>
			<td><input type="password" name="verifyPass" size="32" maxlength="16"></td>
		</tr>
	</table>
<%
	String command = request.getParameter("command");
	
	if(command != null && command.equalsIgnoreCase("CHANGE")){
		String oldPass = request.getParameter("oldPass");
		String newPass = request.getParameter("newPass");
		String verifyPass = request.getParameter("verifyPass");
		String enteredEmail = request.getParameter("email");
		String enteredPrefName = request.getParameter("prefName");

		try{
			if(oldPass.equals("") || newPass.equals("") || verifyPass.equals("")){
				errorMessage = "<font color=\"red\">" + vM.getSentence("passwordFieldEmpty") + "</font>";
				i = 1;
			}	
		}catch(Exception e){
			out.println(errorMessage + "</td></tr></table></body></html>");
			return;
		}

		if(oldPass != null && !oldPass.equals("")){
			//encrypt the new password to check against old
			oldPass = userBean.encrypt(oldPass);
		}

		String currentPassword = cB.getUserAttributeValue("encryptpw");		

		if(!(currentPassword == oldPass || currentPassword.equals(oldPass))){	
			if(i == 0){
				if(!(oldPass == null)){
					errorMessage = "<font color=\"red\">" + vM.getSentence("oldPasswordInvalid") + "</font>";
					i = 1;
				}
			}
		}

		//verifiy that the new password is the same in both places
		if(!(newPass == verifyPass || newPass.equals(verifyPass))){	
			errorMessage = "<font color=\"red\">" + vM.getSentence("passwordNotVerified") + "</font>";
			i = 1;
		}
		
		
		// check to see if the new password is a valid password
		ValidatePassword vp = new ValidatePassword(session, newPass);
		if (!(vp.isValid())){
			errorMessage = "<p class=\"errmsg\">" + vp.getErrorMessages() + "</p>";
			i = 1;
		}
		
		//everything is good,change the password
		if(newPass != null && !newPass.equals("") && i != 1){	
			newPass = userBean.encrypt(newPass);
			cB.setUserAttributeValue("encryptpw",newPass);
			String seccode = cB.getUserAttributeValue("seccode");
			if(!seccode.equalsIgnoreCase("SYSADM"))
				cB.setUserAttributeValue("newPass", "NO");
			else if(seccode.equalsIgnoreCase("SYSADM"))
				try{
					cB.removeUserAttribute("newPass");
				}catch(Exception e){}

			//change the preferred name and email stuff
			if(enteredEmail != null && !enteredEmail.equals("")){
				cB.setUserAttributeValue("email", enteredEmail);
			}
				
			if(enteredPrefName != null && !enteredPrefName.equals("")){
				cB.setUserAttributeValue("name", enteredPrefName);
			}	
			
			
			cB.writeUser();
			String path = "";
			try{
				path = (String)session.getAttribute("URL");
			}catch(Exception e){
				path = "";
			}
				
			if(path != null && path.endsWith("loginPwdChange.jsp")){	
				int index = path.indexOf("loginPwdChange.jsp");
				path = path.substring(0, index);
				path += "HRVhome.jsp";
			}
			
			if(path == null || path.equals(""))
				path = "../Jsp/HRVhome.jsp";
			forwardURL(path,out,request,response);
		}	
	}

%>
<table align="center">
<tr>
<td>
	<%=errorMessage%>
</td>
</tr>
<tr>
<td align="center">
	<input type="submit" class="button" value="<%=change%>" name="changeButton" onclick="setCommand();">
</td>
</tr>
</table>
</td>
</tr>
</table>
	<input type="hidden" name="command" value="">
</form>
</body>
</html>