<%@page import="com.sas.hrv.*" %>
<%@page import="com.sas.net.server.RemoteSasException" %>
<%@page import="com.sas.servlet.beans.mddbtable.commands.MDTableCommandInterface" %>
<%@page import="java.net.URLEncoder"%>
<%@include file="HRVLoginInclude.jsp"%>
<%
boolean _TRACE = false;
if( _TRACE ) System.out.println( "*** Entering mddbViewer.jsp" );
%>
<%@include file="mddbGetCtrl.jsp"%>
<%
	//------------------------
	// process export command  
	//------------------------
	// S0177244 - problem if export command is followed by write command;
	// consequently, return immediately after processing export command
	String  cmd = request.getParameter("CMDNAME");
	if( cmd != null && cmd.startsWith( "EXP" ))
	{
		// execute the Export command and return

		try{ MDTableCommandInterface cmdI = mddbCtrl.processCommand( out, pageContext, cmd, request, response ); }
		catch( java.io.IOException e )
		{
			VisMsg vm = VisMsg.getInstance( session );
			out.println( "<table width=\"100%\" height=\"80%\" cellspacing=\"20\"><tr><td>" );
			out.println( "<p align=\"center\">"+vm.getLabel( "MDDBbadinput" )+"</p>" );
			out.println( "</td></tr></table></body></html>" );
			return;
		}
		catch( Exception e )
		{
			out.println( "<table width=\"100%\" height=\"80%\" cellspacing=\"20\"><tr><td>" );
			out.println( "<p align=\"center\">"+e.toString()+"</p>" );
			out.println( "</td></tr></table></body></html>" );
			return;
		}
		return;
	}	

	//------------------------------
	// process Hrv defined commands  
	//------------------------------
	String  hrvcmd = request.getParameter("CMD");
//System.out.println( "   hrvcmd="+hrvcmd );	
	if( hrvcmd != null )
	{
		if( hrvcmd.equalsIgnoreCase(  MddbHrvCtrl.CMD_RESET_TO_DEFAULT_STATE ))
		{
			mddbCtrl.resetToDefaultState();
		}
//		else if( hrvcmd.equalsIgnoreCase( "RESETSTART" ))
//		{
//			mddbCtrl.resetToStartState();
//		}
		else if( hrvcmd.equalsIgnoreCase(  MddbHrvCtrl.CMD_CHANGE_TO_BOOKMARK_STATE ))
		{
			String bookmarkLocKey = request.getParameter( "BKEY" );
			if( bookmarkLocKey != null && bookmarkLocKey.length() > 0 )
				mddbCtrl.setToBookmarkState( bookmarkLocKey );
		}
		else if( hrvcmd.equalsIgnoreCase( MddbHrvCtrl.CMD_UPDATE_BOOKMARK ))
		{
				mddbCtrl.updateBookmark( request );
		}
		else if( hrvcmd.equalsIgnoreCase( MddbHrvCtrl.CMD_ADD_BOOKMARK ))
		{
				mddbCtrl.addBookmark( request );
		}
		else if( hrvcmd.equalsIgnoreCase( MddbHrvCtrl.CMD_DELETE_BOOKMARK ))
		{
				mddbCtrl.deleteBookmark( request );
		}
		else if( hrvcmd.equalsIgnoreCase( MddbHrvCtrl.CMD_CLEAR_START_BOOKMARK ))
		{
				mddbCtrl.clearStartStateBookmark( request );
		}
		else if( hrvcmd.equalsIgnoreCase(  MddbHrvCtrl.CMD_SHOW_STATE ))
		{
				mddbCtrl.showState();
		}
	}
%>

<HTML><HEAD>
<%@include file="HRVHeadInclude.jsp"%>
<SCRIPT LANGUAGE="javaScript">
   self.focus();
</SCRIPT> 

<TITLE><%=mddbCtrl.getDescription()%></TITLE>
</HEAD>
<BODY class="bodyContents">
<p class="pagetitle"><%=mddbCtrl.getDescription()%></p>

<%
	String sDisplayMddb  = request.getParameter( MddbHrvCtrl.SHOW_MDDB_FIELD );
	String sDisplayGraph = request.getParameter( MddbHrvCtrl.SHOW_GRAPH_FIELD );
	String sGraphType    = request.getParameter( MddbHrvCtrl.GRAPH_TYPE_FIELD );

	if( sDisplayMddb != null && sDisplayMddb.length() > 0 )
	{
		boolean  displayMddb  = Boolean.valueOf(sDisplayMddb).booleanValue();
		mddbCtrl.setDisplayMddbTable( displayMddb );
	}
	
	if( sDisplayGraph != null && sDisplayGraph.length() > 0 )
	{
		boolean  displayGraph  = Boolean.valueOf(sDisplayGraph).booleanValue();
		mddbCtrl.setDisplayMddbGraph( displayGraph );
	}

	if( sGraphType != null && sGraphType.length() > 0 )
	{
		int      graphType    = Integer.valueOf(sGraphType).intValue();
		mddbCtrl.setGraphType( graphType );
	}

	//---------------------------------- 
	// Process ADS Commands & Draw MDDB
	//---------------------------------- 
   try
   {
		String  pre = request.getParameter("PRECOMPLETE");

		if(( cmd != null && cmd.startsWith( "QRY" ) ) &&
		   ( pre == null || !pre.equals( "YES" )    ))
		{
			//------------------------------ 
			// Pre-process Query Command
			//------------------------------ 
			NamedList newMeasures = mddbCtrl.preprocessQueryCommand( request, response );
//if( newMeasures==null )
//System.out.println( "newMeasures=null" );			
//else
//System.out.println( "newMeasures="+newMeasures.toString() );			
			if( newMeasures != null && newMeasures.length() > 0 )
			{
				// update parameters and forward back to this jsp

				/*------------------------------------------------------*/
				/* Get the Url of the page that is including this file. */
				/*------------------------------------------------------*/
				/* Cannot use getQueryString() because DPD beans POST.  */
				/* POST parameters do not show up on the getQueryString.*/
				/*------------------------------------------------------*/
				String thisUrlParams = "";
				Enumeration parms = request.getParameterNames();
				boolean     first = true;
				while( parms.hasMoreElements() )
				{
					String parmName = (String)parms.nextElement();

					// don't bother putting formulas on for the second pass
					if( parmName.equals( MddbHrvCtrl.FORMULA_PARM ))
						continue;

					if( parmName.equals( MddbHrvCtrl.MEASURE_PARM ))
					{
						// pass on required and selected measures
						for( int i = 0; i < newMeasures.length(); ++i )
						{
							String parmValue = (String)newMeasures.getValue(i);
//System.out.println( "  parmValue:  "+parmValue );							
//							parmValue = URLEncoder.encode(parmValue);
//System.out.println( "  parmValue(encoded):  "+parmValue );							
							if( !first ) thisUrlParams += "&";
							else         first = false;
							thisUrlParams += parmName + "=" + parmValue;
						}
					}
					else
					{
						// pass on all other parameters
						String [] parmValues = request.getParameterValues( parmName );
						for( int i = 0; i < parmValues.length; ++i )
						{
//System.out.println( "  parmValues["+i+"]:  "+parmValues[i] );							
							String parmValue = parmValues[i];
//							String parmValue = URLEncoder.encode(parmValues[i]);
//System.out.println( "  parmValue(encoded):  "+parmValue );							
							if( !first ) thisUrlParams += "&";
							else         first = false;
							thisUrlParams += parmName + "=" + parmValue;
						}
					}
				}
				thisUrlParams += "&PRECOMPLETE=YES";							
				String newUrl = "../Jsp/mddbViewer.jsp?"+thisUrlParams;

//System.out.println( "mddbViewer.jsp: newUrl= "+newUrl );

				forwardURL(newUrl,out,request,response);
				return;
			}
		}

		//------------------------------ 
		// Process Commands
		//------------------------------ 
		MDTableCommandInterface cmdI = null;
		boolean isShowDetailCmd = false;
		if( cmd != null && cmd.length() > 0 )
		{
			// This page will get called anytime you want to drilldown, go up, or scroll.
			// In each case a command name is set when a form is submitted.  The command
			// name is used to look up the necessary information on the server to execute
			// the command.  
				 
			try{ cmdI = mddbCtrl.processCommand( out, pageContext, cmd, request, response ); }
			catch( java.io.IOException e )
			{
				VisMsg vm = VisMsg.getInstance( session );
				out.println( "<table width=\"100%\" height=\"80%\" cellspacing=\"20\"><tr><td>" );
				out.println( "<p align=\"center\">"+vm.getLabel( "MDDBbadinput" )+"</p>" );
				out.println( "</td></tr></table></body></html>" );
				return;
			}
			catch( Exception e )
			{
				out.println( "<table width=\"100%\" height=\"80%\" cellspacing=\"20\"><tr><td>" );
				out.println( "<p align=\"center\">"+e.toString()+"</p>" );
				out.println( "</td></tr></table></body></html>" );
				return;
			}
				
			isShowDetailCmd = mddbCtrl.isShowDetailCmd( cmdI );
		}
		
		// When the page is called without the CMDNAME parameter cmd will
		// be null.  This is the first time the MDDB is being displayed
		// so all we need to do is write it out.
		//
		// The write also occurs when any command other than showDetail is 
		// passed in.  The other commands simply change the display of the mddb.

		if( !isShowDetailCmd )
		{
			//------------------------------ 
			// Draw MDDB
			//------------------------------ 
			try{ mddbCtrl.writeMddb( out, request, response ); }
			catch( org.omg.CORBA.UNKNOWN e )
			{
				VisMsg vm = VisMsg.getInstance( session );
				if( cmd.substring( 0,3 ).equalsIgnoreCase( "QRY" ))
				{
					mddbCtrl.close();
					
					out.println( "<script language=\"javaScript\">" );
					out.println( "  alert( \""+vm.getLabel( "MDVdimwriteError" )+"\"); " );
					out.println( "  var url = \"openMddb.jsp?key="+mddbName+"&location="+locstr+"\";" );
					out.println( "  parent.document.location=url;" );
					out.println( "</script>" );
					out.println( "</body></html>" );
					return;
				}

				out.println( "<table width=\"100%\" height=\"80%\" cellspacing=\"20\"><tr><td>" );
				out.println( "<p align=\"center\">"+e.toString()+"</p>" );
				out.println( "</td></tr></table></body></html>" );
				return;
			}
			catch( Exception e )
			{
				out.println( "<table width=\"100%\" height=\"80%\" cellspacing=\"20\"><tr><td>" );
				out.println( "<p align=\"center\">"+e.toString()+"</p>" );
				out.println( "</td></tr></table></body></html>" );
				return;
			}
		}
		else
		{
//System.out.println( "Showing Detail Table..." );			
			//------------------------------ 
			// Draw Detail Table
			//------------------------------ 

			/*
			 * All commands are sent back to the mddbViewer.jsp.  Most commands
			 * effect the way the MDDB is displayed.  The showDetail command needs
			 * to show the detail table using the openTable.jsp).  
			 *
			 * We've intercepted the command at this point.  All we need to do is 
			 * get the name of the detail table and the where clause to apply 
			 * levels, stat limits, and user subsets.  Then forward on to openTable.
			 */
			String detailLibref = mddbCtrl.getDetailTableLibref();
			String detailLocStr = mddbCtrl.getDetailTableLocation();
			String detailName   = mddbCtrl.getDetailTableName();				
			String detailWhere  = mddbCtrl.getDetailWhere( cmdI );
			String highlightCol = mddbCtrl.getDetailMeasure( cmdI );
			
			boolean useView = false;
			if( detailLocStr == null )
				useView = true;
			
			String tableViewerUrl = "../Jsp/newWindow.jsp?../Jsp/openTable.jsp?";
			
			if( useView )
				tableViewerUrl +=
					"currentView="+detailLibref+"."+detailName+
					"&viewOnly=y"+
					"&ctrlButtons=false"+
  					"&hideWhere=y"+
					"&colHighlt="+highlightCol;
			else
				tableViewerUrl +=				
					"key="+detailName+
					"&type=Table"+
					"&location="+detailLocStr+
					"&ctrlButtons=false"+
					"&hideWhere=y"+
					"&colHighlt="+highlightCol;

			if( detailWhere != null && detailWhere.length() > 0 )
				tableViewerUrl += "&subset="+detailWhere;
					
//System.out.println( "tableViewerUrl: "+tableViewerUrl );
			
			forwardURL(tableViewerUrl,out,request,response);
			return;
		}
   }
 
   catch (Exception ex) 
   {
      ex.printStackTrace(new PrintWriter(out));
      out.println( "<P> Exception: "+ex+"</p>" );
   }  

	String mddbFormName = mddbCtrl.getMddbFormName();

	mddbCtrl.writeExportToExcel(out, request, response);
%>

<form name="HrvMddbInfo">
  <input type="hidden" name="mddbFormName" value="<%=mddbFormName%>">
</form>

<script language="JavaScript">
  // script must be at the end of the file to insure that the mddb is fully
  // loaded before attempting to write the navbar in the buttons frame
  var newBtnUrl = parent.BUTTONS.location + "&writeNav=YES";
  parent.BUTTONS.location=newBtnUrl;
<%
	if( !isAnalysis )
	{
%>
  parent.ICONS.location=parent.ICONS.location;
<%
	}
%>
</script>

</BODY>
</HTML>

<%
if( _TRACE ) System.out.println( "--- Leaving mddbViewer.jsp" );
%>
