<%@page import="java.io.*,java.util.*" %>
<%@page import="com.sas.hrv.*" %>

<%@page import="com.sas.sasserver.dataset.*" %>
<%@page import="com.sas.rmi.*" %>
<%@page import="com.sas.servlet.util.*" %>

<%@ include file="HRVLoginInclude.jsp"%>
<html>
<head>
   <%@ include file="HRVHeadInclude.jsp"%>
</head>

<%
VisMsg vM = VisMsg.getInstance (session);
%>

<%  
    String buttonCopy = (String)vM.getLabel ("Copy");
    String buttonOk = (String)vM.getLabel ("OK");
    String buttonReset = (String)vM.getLabel ("Reset");
    String buttonCancel = (String)vM.getLabel ("Cancel");
    String javascriptButtonOK = (String)vM.getLabel ("PROPSok_button.notrans");
    String javascriptButtonCopy = (String)vM.getLabel ("PROPScopy_button.notrans");
    String javascriptButtonCancel = (String)vM.getLabel ("PROPScancel_button.notrans");
    String javascriptButtonReset = (String)vM.getLabel ("PROPSreset_button.notrans");
    String javascriptButtonBuild = (String)vM.getLabel ("PROPSbuild_button.notrans");

    String HRVBUTTONAREA = (String)vM.getLink ("ButtonArea");

try {
    final String DEFAULT_STRING = "TABLEPROPS";
    
    NamedList tableLabels = vM.getLabelList ("TABLE_PROPS*");

    // get items off of the request
    String key = request.getParameter ("key");
    String properKey = request.getParameter ("properKey");
    String command = request.getParameter ("command");
    String location = request.getParameter ("location");

    String topic = request.getParameter ("topic");
    String window = request.getParameter ("window");
    String explorerType = request.getParameter ("explorerType");
    String actualType = request.getParameter ("actualType");

    if (actualType == null) {
        actualType = "TABLE";
        explorerType = "TABLES";
    }

    final String [] tableAttrs = { "desc", "applysec", "master",
                                   "program", "bldorder",
                                   "wh_refresh", "security" };
    
    final String [] tableAttrsTypes = { "field", "drop", "drop",
                                    "field", "field", "check", "drop" };
    

    String [] requestValues = new String [tableAttrs.length];
    for (int i = 0; i < tableAttrs.length; i++) {
        requestValues[i] = request.getParameter ("table" + tableAttrs[i]);
    }
    
    String tableAttrString = "", tableAttrTypeString = "", requestString = "";
    for (int i = 0; i < tableAttrs.length; i++) {
        tableAttrString += "\"" + tableAttrs[i] + "\"";
        tableAttrTypeString += "\"" + tableAttrsTypes[i] + "\"";
        requestString += "\"" + requestValues[i] + "\"";
        if (i < tableAttrs.length - 1) {
            tableAttrString += ",";
            tableAttrTypeString += ",";
            requestString += ",";
        }
    }
        
    String title;

    String saveString = request.getParameter ("saveString");
    if (null == saveString) {
        saveString = "SAVE";
    }

    String tablePropsKey = key;
    
    TablePropertyBean tableProps = null;

    // get the metadata file
    TableBean thisTable = (TableBean)session.getAttribute (key);
    TableBean properTable = (TableBean)session.getAttribute (properKey);
    
    if (properTable == null && properKey != null && !properKey.equals ("null")) {
        properTable = new TableBean (session);
        properTable.setMetaLocation (Integer.parseInt (location));
        properTable.setMetaKey (properKey);
    }

    NamedList tableList = new NamedList (true);

    // process commands
    if (command != null) {
        // no commands for tables
    }

    // create the property bean
    tableProps = new TablePropertyBean (session, thisTable, properTable, command, key);
    if (command != null && 
        command.equalsIgnoreCase ("NEW") && 
        saveString.equalsIgnoreCase ("NEWSAVE")) {
        tableProps.createTable ();
    }

    // save the properties
    HrvInfo.setSessionValue (session, tablePropsKey, tableProps);

    // get the title
    if ((command != null && command.equals ("NEW")) || key.equals (DEFAULT_STRING)) {
        title = vM.getLabel ("NEW_TABLEtitle");
    } else {
        title = thisTable.getAttributeValue ("desc");
    }

    if (null == title) {
        title = vM.getLabel ("NEW_TABLEtitle");
    } 

    // get the name of our form
    String formname = (String)tableLabels.getValue ("TABLE_PROPSformname.notrans");
    
    NamedList columns = tableProps.getColumns ();
    
    
    //##################### sort the column names ###############
    
    OptionBean oB = OptionBean.getInstance(session);
    String sortOrder = oB.getOption("sort_order");
    if(sortOrder == null || sortOrder.equals("NOSORT"))
	sortOrder = "NOSORT"; 
    else if(sortOrder.equals("SORTASC_NAME"))
	columns.sortByAscendingName(true);
    else if(sortOrder.equals("SORTDESC_NAME"))
    	columns.sortByDescendingName(true);
    else if(sortOrder.equals("SORTASC_VALUE"))
    	columns.sortByLabelValue(true);
    else if(sortOrder.equals("SORTDESC_VALUE"))
    	columns.sortByLabelValue(false);
    else if(sortOrder.equals("TABLE_VIEW"))
    	thisTable.orderByVisual(columns);
    	
    	
    //##################### sort the column names ###############
    
    
    NamedList curColumnList;
    String columnArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnParentArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnKeyArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnIndexArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnSecurityArrayString =
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnDescArrayString =
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnTypeArrayString =
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnLengthArrayString =
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnFormatArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnInformatArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnOrderArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";   
    String columnAnalTypeArrayString =
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    String columnNameArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";  
    String columnExtDescArrayString = 
        columns.size()==0?"\"" + vM.getLabel("Error.txt") + "\"":"";
    
    for (int i = 0; i < columns.size (); i++) {
        String curColumn = columns.getName (i);
        
        columnArrayString += "\"" + curColumn + "\"";
        curColumnList = (NamedList)columns.getValue (i);

        String curDesc = (String)curColumnList.getValue ("desc");

        columnParentArrayString += "\"" + curColumnList.getValue ("parent") + "\"";
        columnKeyArrayString += "\"" + curColumnList.getValue ("key") + "\"";
        columnIndexArrayString += "\"" + curColumnList.getValue ("index") + "\"";
        Object tmpValue = curColumnList.getValue ("security");
        if (tmpValue == null)
              tmpValue = "";
        columnSecurityArrayString += "\"" + tmpValue + "\"";
        columnDescArrayString += "\"" + curDesc + "\"";
        columnTypeArrayString += "\"" + curColumnList.getValue ("type") + "\"";
        columnLengthArrayString += "\"" + curColumnList.getValue ("length") + "\"";
        columnFormatArrayString += "\"" + curColumnList.getValue ("format") + "\"";
        columnInformatArrayString += "\"" + curColumnList.getValue ("informat") + "\"";
        columnOrderArrayString += "\"" + curColumnList.getValue ("order") + "\"";
        columnAnalTypeArrayString += "\"" + curColumnList.getValue ("analtype") + "\"";
        tmpValue = curColumnList.getValue ("extdesc");
        if (tmpValue == null)
              tmpValue = "";
        columnExtDescArrayString += "\"" + tmpValue + "\"";
        
        String curName = curDesc;
        if (curDesc.equals ("")) {
            curName = curColumn;
        }
        columnNameArrayString += "\"" + curName + "\"";
        
        if (i < (columns.size() - 1)) {
            columnArrayString += ",";
            columnParentArrayString += ",";
            columnKeyArrayString += ",";
            columnIndexArrayString += ",";
            columnSecurityArrayString += ",";
            columnDescArrayString += ",";
            columnTypeArrayString += ",";
            columnLengthArrayString += ",";
            columnFormatArrayString += ",";
            columnInformatArrayString += ",";
            columnOrderArrayString += ",";
            columnAnalTypeArrayString += ",";
            columnNameArrayString += ",";
            columnExtDescArrayString += ",";
        }           
    }   
    
%>

<script language="javascript">
<!--

    attrs = new Array (<%=tableAttrString%>);
    attrTypes = new Array (<%=tableAttrTypeString%>);
    request = new Array (<%=requestString%>);

    formArray = new Array ("coldesc","colparent","colkey","colsecurity",
                           "coltype","collength","colformat","colinformat",
                           "colanaltype", "colextdesc", "colorder");

    formItemArray = new Array ( "columndesc","columnparent","columnkey","columnsecurity",
                           
                        "columntype","columnlength","columnformat","columninformat",
                           "columnanaltype", "columnextdesc", "columnorder");


    stringColumnArray = new Array ("Desc","Parent","Key","Security",
                           "Type","Length","Format","Informat",
                           "AnalType", "ExtDesc", "Order");


    // we can pretend that extdesc is a field since they have same
    // attributes
    formTypeArray = new Array ("field","field","field", "drop", 
                               "drop", "field", "field", "field",
                               "check", "field", "field");

    columnArray = new Array (<%=columnArrayString%>);
    columnParentArray = new Array (<%=columnParentArrayString%>);
    columnKeyArray = new Array (<%=columnKeyArrayString%>);
    columnIndexArray = new Array (<%=columnIndexArrayString%>);
    columnSecurityArray = new Array (<%=columnSecurityArrayString%>);
    columnDescArray = new Array (<%=columnDescArrayString%>);
    columnNameArray = new Array (<%=columnNameArrayString%>);
    columnTypeArray = new Array (<%=columnTypeArrayString%>);
    columnLengthArray = new Array (<%=columnLengthArrayString%>);
    columnFormatArray = new Array (<%=columnFormatArrayString%>);
    columnInformatArray = new Array (<%=columnInformatArrayString%>);
    columnOrderArray = new Array (<%=columnOrderArrayString%>);
    columnAnalTypeArray = new Array (<%=columnAnalTypeArrayString%>);   
    columnExtDescArray = new Array (<%=columnExtDescArrayString%>);

    // keep secondary ones of these for the propagation
    columnDescPropagateArray = new Array (<%=columnDescArrayString%>);
    columnFormatPropagateArray = new Array (<%=columnFormatArrayString%>);
    columnInformatPropagateArray = new Array (<%=columnInformatArrayString%>);
    columnTypePropagateArray = new Array (<%=columnTypeArrayString%>);
    columnSecurityPropagateArray = new Array (<%=columnSecurityArrayString%>);
    columnExtDescPropagateArray = new Array (<%=columnExtDescArrayString%>);

    function saveCurrent () {
        if (columnArray.length > 0) {
            for (i = 0; i < formArray.length; i++) {

                curCtrl = eval ('document.<%=formname%>.' + formArray[i]);
                curArray = eval ('column' + stringColumnArray[i] + 'Array');

                if (formTypeArray[i] == "field") {
                    curArray[parseInt(oldColumn)] = curCtrl.value;
                    if (formArray[i] == "coldesc") {
                        document.<%=formname%>.name.options[parseInt(oldColumn)].text = '(' + columnArray[parseInt(oldColumn)] + ') ' + curCtrl.value;
                        columnNameArray[parseInt(oldColumn)] = 
                            '(' + columnArray[parseInt(oldColumn)] + ') ' + curCtrl.value;
                    }
                } else if (formTypeArray[i] == "drop") {
                    curArray[parseInt(oldColumn)] = curCtrl.options[curCtrl.options.selectedIndex].value;
                } else if (formTypeArray[i] == "check") {
                    if (curCtrl.checked == true) {
                        curArray[parseInt(oldColumn)] = "Y";
                    } else {
                        curArray[parseInt(oldColumn)] = "N";
                    }
                }
            }
        }
    }
    
    function changeColumns () {
        curColumn = document.<%=formname%>.name.options.selectedIndex;
        if (curColumn < 0)
            curColumn = 0;

        oldColumn = curColumn;
        for (i = 0; i < formArray.length; i++) {
            curCtrl = eval ('document.<%=formname%>.'+ formArray[i]);

            curArray = eval ('column' + stringColumnArray[i] + 'Array');

            curValue = curArray[parseInt (curColumn)];
            if (curValue == "null") 
                curValue = "";
            if (formTypeArray[i] == "field") {
                curCtrl.value = curValue;
            } else if (formTypeArray[i] == "drop") {
                for (j = 0; j < curCtrl.options.length; j++) {
                    if (curValue == curCtrl.options[j].value) {
                        curCtrl.options.selectedIndex = j;
                    }
                }
            } else if (formTypeArray[i] == "check") {
                if (curValue == "Y") {
                    curCtrl.checked = true;
                } else {
                    curCtrl.checked = false;
                }
            }
        }
    }

    function writeFormValues () {
        curItem = '';
        for (i = 0; i < columnArray.length; i++) {
            curItem = curItem + columnArray[i] + String.fromCharCode(182);
        }
        document.<%=formname%>.column.value = curItem;

        for (i = 0; i < formArray.length; i++) {
            curItem = '';
            curArray = eval ('column' + stringColumnArray[i] + 'Array');
            curFormItem = eval ('document.<%=formname%>.' + formItemArray[i]);

            for (j = 0; j < curArray.length; j++) {
                if (curArray[j] == 'null') {
                    curArray[j] = '';
                }
                curItem = curItem + curArray[j] + String.fromCharCode(182);
            }
            
            curFormItem.value = curItem;
        }
    }

    function init () {
    
        for (j = 0; j < attrs.length; j++) {
            thisCtrl = eval ('document.<%=formname%>.' + attrs[j]);
            if (attrTypes[j] == "field") {
                thisCtrl.value = request[j];
            } else if (attrTypes[j] == "drop") {
                thisCtrl.selectedIndex = parseInt (request[j]);
            } else if (attrTypes[j] == "check") {
                if (request[j] == 'true')
                    thisCtrl.checked = true;
                else 
                    thisCtrl.checked = false;
            }
        }

    }
    
    function colsFocusFunction (thisCtrlName) {
        thisCtrl = eval ('document.<%=formname%>.' + thisCtrlName); 
        if (document.<%=formname%>.updatecols.checked == true ||    
            document.<%=formname%>.updatecols.disabled == true) {
    
            // only blur if this control isn't disabled
            if (thisCtrl.disabled == false) {
                thisCtrl.blur ();
<%
// if user can edit this table
if ((location.equals (MetaBean.PUBLIC_LOC_STRING) && HrvInfo.isUserAdmin (session)) ||
        location.equals (MetaBean.PRIVATE_LOC_STRING)) {
%>
                document.<%=formname%>.coltype.focus ();
<%
} else {
%>
                document.<%=formname%>.colextdesc.focus ();
<%
}
%>
            }
        } 
    }
    
    function updateCols () {
/*      if (document.<%=formname%>.updatecols.checked == true ||
            document.<%=formname%>.updatecols.disabled == true) {
            document.<%=formname%>.coltype.disabled = true;
        } else {
            document.<%=formname%>.coltype.disabled = false;
        }*/
    }
    
<%

    String tbltype = thisTable.getAttributeValue ("tbltype");
    if (tbltype != null && tbltype.equalsIgnoreCase ("SAS")) {
%>
    function onChange () {
        checked = document.<%=formname%>.usesystem.checked;
        disabled = document.<%=formname%>.datapw.disabled;
        
        if (checked == true && disabled == false) {
            document.<%=formname%>.datapw.disabled = true;
        } else {
            document.<%=formname%>.datapw.disabled = false;
        }
    }
<%
    }
%>

    function propagateColumns () {
        var column = String.fromCharCode(182);
        var attr = String.fromCharCode(182);
        var val = String.fromCharCode(182);
        // iterate over all columns
        for (i = 0; i < columnArray.length; i++) {
            // check description
            if (columnDescArray[i] != columnDescPropagateArray[i]) {

                column += columnArray[i] + String.fromCharCode(182);
                attr += 'desc' + String.fromCharCode(182);
                val += columnDescArray[i] + String.fromCharCode(182);
            }
            
            // check format
            if (columnFormatArray[i] != columnFormatPropagateArray[i]) {
                column += columnArray[i] + String.fromCharCode(182);
                attr += 'format' + String.fromCharCode(182);
                val += columnFormatArray[i] + String.fromCharCode(182);
            }
            
            // check informat
            if (columnInformatArray[i] != columnInformatPropagateArray[i]) {
                column += columnArray[i] + String.fromCharCode(182);
                attr += 'informat' + String.fromCharCode(182);
                val += columnInformatArray[i] + String.fromCharCode(182);
            }

            // check type
            if (columnTypeArray[i] != columnTypePropagateArray[i]) {
                column += columnArray[i] + String.fromCharCode(182);
                attr += 'type' + String.fromCharCode(182);
                val += columnTypeArray[i] + String.fromCharCode(182);
            }

            // check security
            if (columnSecurityArray[i] != columnSecurityPropagateArray[i]) {
                column += columnArray[i] + String.fromCharCode(182);
                attr += 'security' + String.fromCharCode(182);
                val += columnSecurityArray[i] + String.fromCharCode(182);
            }
            
            // check extended description
            if (columnExtDescArray[i] != columnExtDescPropagateArray[i]) {
                column += columnArray[i] + String.fromCharCode(182);
                attr += 'extdesc' + String.fromCharCode(182);
                val += columnExtDescArray[i] + String.fromCharCode(182);
            }
        }
        
        // variables created above can now be assigned to the form values
        // if we found a difference
        if (column != String.fromCharCode(182)) {
            // set the indicator that we'll need to propagate columns
            document.<%=formname%>.columnpropagateindicator.value = 'Y';
            
            document.<%=formname%>.propagatecolumn.value = column;
            document.<%=formname%>.propagatecolumnattr.value = attr;
            document.<%=formname%>.propagatecolumnval.value = val;
        }
    }

    function disableCopyButton () {
        try {
            // if this field is checked, then disable the button
            if (document.<%=formname%>.notallowcopy.checked == true) {
                parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonCopy%>.disabled = true;    
            } else {
                // it isn't checked, make it usable
                parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonCopy%>.disabled = false;   
            }
        } catch (Exception) {
        }
    }
    
//-->
</script>

<body class="bodyContents" onLoad="self.status='';">
             
<center><h1><%=title%></h1></center>

<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td width="100%">


<form target="_top" method="POST" action="propertiesItem.jsp" name="<%=formname%>">

<%
    out.println (tableProps.toHtml ());
%>

<input type="hidden" name="command" value="<%=saveString%>">
<input type="hidden" name="saveString" value="<%=saveString%>">
<input type="hidden" name="key" value="<%=key%>">
<input type="hidden" name="properKey" value="<%=properKey%>">
<input type="hidden" name="location" value="<%=location%>">
<!-- <input type="hidden" name="type" value="TABLE"> -->

<input type="hidden" name="topic" value="<%=topic%>">
<input type="hidden" name="window" value="<%=window%>">
<input type="hidden" name="explorerType" value="<%=explorerType%>">
<input type="hidden" name="actualType" value="<%=actualType%>">

<!-- column information -->
<input type="hidden" name="column" value=""> 
<input type="hidden" name="columnparent" value=""> 
<input type="hidden" name="columnkey" value=""> 
<input type="hidden" name="columnindex" value=""> 
<input type="hidden" name="columnsecurity" value=""> 
<input type="hidden" name="columndesc" value=""> 
<input type="hidden" name="columntype" value=""> 
<input type="hidden" name="columnlength" value=""> 
<input type="hidden" name="columnformat" value=""> 
<input type="hidden" name="columninformat" value=""> 
<input type="hidden" name="columnorder" value=""> 
<input type="hidden" name="columnanaltype" value=""> 
<input type="hidden" name="columnextdesc" value="">
<!-- end column information -->

<!-- propagation -->
<input type="hidden" name="columnpropagateindicator" value="N">
<input type="hidden" name="propagatecolumn" value="">
<input type="hidden" name="propagatecolumnattr" value="">
<input type="hidden" name="propagatecolumnval" value="">
<!-- end propagation -->

</form>

</td>
</tr>
</table>

<script language="javascript">
<!--
    changeColumns ();
    updateCols ();
    disableCopyButton ();
<%
    if (tbltype != null && tbltype.equalsIgnoreCase ("SAS")) {
        out.println ("onChange ();");
    }
%>
<%
    if (command != null && command.equalsIgnoreCase ("COLUMN")) {
        out.println ("init ();");
    }
%>
//-->
</script>

<%
} catch (ConnectionErrorException e) {
%>

<script language="javascript">
<!--
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonCopy%>.disabled = true;    
    
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonOK%>.disabled = true;  
    
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonReset%>.disabled = true;   
    
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonCancel%>.disabled = true;  
//-->
</script>

<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>
<p class="ERRMSG">

<%=vM.getLabel ("ConnectionError")%>

</p>
</td>
</tr>
</table>

</td></tr>
</table>

<%
} catch (Exception e) {
%>
<script language="javascript">
<!--
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonCopy%>.disabled = true;    
    
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonOK%>.disabled = true;  
    
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonReset%>.disabled = true;   
    
    parent.parent.<%=HRVBUTTONAREA%>.document.tablebuttonform.<%=javascriptButtonCancel%>.disabled = true;  
//-->
</script>

<table width="100%" height="100%">
<tr><td valign=center align=center>

<table>
<tr>
<td valign=center align=center>

<p class=ERRMSG>
<%=vM.getLabel ("PROPS_errmsg")%>
<br>
<%=vM.getLabel ("PROPS_errmsg_bookmark")%>
<br>
<%
out.println ("Exception: " + e.toString ());
%>
</p>

</td>
</tr>
</table>

</td></tr>
</table>
<%
}
%>

</body>
</html>