<%-- Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 --%>
<%@ page errorPage="../Query/QueryErr.jsp" %>
<%@ page import="java.io.*, java.util.*" %>
<%@ page import="com.sas.query.*" %>
<%@ page import="com.sas.query.app.*" %>
<%@ page import="com.sas.query.datasources.*" %>
<%@ page import="com.sas.query.models.*" %>
<%@ page import="com.sas.query.models.Expression" %>
<%@ page import="com.sas.query.visuals.*" %>
<%@ page import="com.sas.hrv.*" %>
<%@ page import="com.sas.rmi.Connection" %>
<%@ page import="com.sas.models.*" %>
<%@ page import="com.sas.servlet.beans.*" %>
<%@ page import="com.sas.servlet.beans.html.*" %>
<%@ include file="../Jsp/HRVLoginInclude.jsp" %>
<%@ include file="../Query/QueryInclude.jsp" %>
<%
   VisMsg bundle = (VisMsg)request.getAttribute("resources");
   String m_pageTitle           = bundle.getString( "Values.PageTitle.txt" );
   String m_pageLabel           = bundle.getString( "Values.PageLabel.txt" );

   String m_newPromptLabel      = bundle.getString( "Values.NewUserPromptButton.txt" );
   String m_editPromptLabel     = bundle.getString( "Values.EditUserPromptButton.txt" );
   String m_deletePromptLabel   = bundle.getString( "Values.DeleteUserPromptButton.txt" );
   String m_noColumnMessage     = bundle.getString("Values.Message.NoColumnSelected.txt");
   String m_noPromptMessage     = bundle.getString("Values.Message.NoPromptSelected.txt");

   Integer m_itemNum = (Integer)request.getAttribute("itemNum");
   BaseTransformation m_valuesBean = (BaseTransformation)request.getAttribute("valuesBean");
   BaseTransformation m_columnBean = (BaseTransformation)request.getAttribute("columnBean");
   BaseTransformation m_typeBean = (BaseTransformation)request.getAttribute("typeBean");
   
   //new ******
   NamedList vals = (NamedList)request.getAttribute("vals"); 
%>
<HTML>
<HEAD>
   <TITLE><%= m_pageTitle %></TITLE>
   <%@ include file="../Jsp/HRVHeadInclude.jsp"%>
<SCRIPT>
colChoice = null;
operator = null;
operand1 = null;

function GetOpenerElements() {
   if (opener != null) {
      colChoice = opener.document.forms["initQry"].elements["item<%= m_itemNum %>.column"];
      operator = opener.document.forms["initQry"].elements["item<%= m_itemNum %>.operator"];
      operand1 = opener.document.forms["initQry"].elements["item<%= m_itemNum %>.operand1"];
   }
}

function UpdateColumnValue() {
   GetOpenerElements();
   colValue = document.initQry.elements["column"];
   if (colChoice != null) {
      colValue.value = colChoice.value;
   }

   valueList = document.initQry.elements["values"];
   if (operator != null && valueList != null) {
      if (operator.value == 'IN') {
         valueList.multiple = true;
      } else {
         valueList.multiple = false;
      }
   }
}

function GetValues(cmd) {
   UpdateColumnValue();
   if (colChoice != null && colChoice.selectedIndex > 0) {
      document.initQry.submit();
   } else {
      alert("<%= m_noColumnMessage %>");
   }
}

function OnOK() {
   valueList = document.initQry.elements["values"];
   if (operand1 != null && valueList != null) {
      var opValue = valueList.value;

      if (valueList.multiple) {
         //we need to do some processing here:
         //  check for commas in each value selected
         //    if a value has a comma, then it needs to be in quotes
         //    quoted values need to have internal quotes escaped.
         //  the return value then becomes the concatenation of each processed
         //  value joined by commas
         var first = true;
         opValue = "";
         for (i=0; i<valueList.options.length; i++) {
            var option = valueList.options(i);
            if (option.selected) {
               var val = option.value;
               //process value

               //1st, look for 1 or more commas
               if (val.indexOf(",") != -1) {
                  //value has 1 or more commas and should be quoted
                  if (val.indexOf("'") != -1) {
                     var chunks = val.split("'");
                     val = chunks[0];
                     for (var j=1; j<chunks.length; j++) {
                        val += "''" + chunks[j];
                     }
                  }

                  val = "'"+val+"'";
               }

               //add value to the return value
               if (first == false) {
                  opValue += ", ";
               }
               first = false;
               opValue += val;
            }
         }
      }

      operand1.value = opValue;
   }
   window.close();
}

function OnSwitchToMulti() {
   valueList = document.initQry.elements["values"];
   if (valueList != null) {
      valueList.multiple = true;
   }
}

function OnSwitchToSingle() {
   valueList = document.initQry.elements["values"];
   if (valueList != null) {
      valueList.multiple = false;
   }
}
</SCRIPT>
</HEAD>

<BODY CLASS="bodyContents">

<CENTER><H1><%= m_pageLabel %></H1></CENTER>
<TABLE BORDER=0 WIDTH="100%" HEIGHT="100%">
<TR ALIGN=CENTER><TD VALIGN=CENTER>

<TABLE>

<TR><TD><SPAN CLASS="ERRMSG"><%= request.getAttribute("error.msg") %></SPAN></TD></TR>

<TR ALIGN=CENTER>
<TD>
<FORM NAME="initQry" ACTION="ValueSelector.jsp">
<INPUT TYPE=HIDDEN NAME="sessionkey" VALUE="<%= m_sessionKey %>">
<INPUT TYPE=HIDDEN NAME="intAction" VALUE="">
<INPUT TYPE=HIDDEN NAME="item" VALUE="<%= m_itemNum %>">
<% m_columnBean.write(out); %>


<TABLE CLASS="ENTRYBOX" BORDER=0 CELLSPACING=2>

<TR>
<TD VALIGN=TOP>

<% 
// redo this code (10/15/2003) to use vals, if present, and write out a selector control
// otherwise use the bean as before
Long startreq = (Long) request.getAttribute("startTime");
long start = System.currentTimeMillis();
if (startreq != null) start = startreq.longValue();
if (vals != null){
  out.println("<select name='values' size='7'>");
  out.println("<option value='                              '></option>");
  for (int i=0; i < vals.size();i++) {
    out.println("<option value='" + vals.getName(i) + "'>" + vals.getValue(i) + "</option>");
  }
  out.println("</select>");
  System.out.println("Generate select control - Time: " + (System.currentTimeMillis() - start));
}//end of new code
else {
  if (m_valuesBean != null) {
    m_valuesBean.write(out);
    //System.out.println("Bean write time: " + (System.currentTimeMillis() - start));
  }
}

%> 
</TD>
<TD VALIGN=TOP> <% m_typeBean.write(out); %>
</TD>
</TR>
</TABLE>
</FORM>

<SCRIPT>
UpdateColumnValue();
</SCRIPT>


<!-- ---------- NAV TOOL ---------- -->
<FORM>
<TABLE WIDTH=100%>
<TR>
<%
   if (m_usageMode == USAGE_ALL) {
      String returnURL = "../Query/ValueSelector.jsp?sessionkey=" + m_sessionKey + "&item=" + m_itemNum;
      session.setAttribute("returnURL", returnURL);

%>
<TD ALIGN=CENTER>
<SCRIPT>
function OnNewPrompt() {
   document.location.href="../Jsp/userPrompt.jsp?command=CREATE";
}
function OnEditPrompt() {
   valueList = document.initQry.elements["values"];
   if (valueList != null && valueList.selectedIndex >= 0) {
      key=valueList.value.substring(1);
      document.location.href="../Jsp/userPrompt.jsp?command=EDIT&key="+key;
   } else {
      alert("<%= m_noPromptMessage %>");
   }
}

function OnDeletePrompt() {
   valueList = document.initQry.elements["values"];
   if (valueList != null && valueList.selectedIndex >= 0) {
      key=valueList.value.substring(1);
//      document.location.href="../Jsp/userPrompt.jsp?command=EDIT&key="+key;
        //BKD:FIX!!!
      document.initQry.intAction.value = "delete";
      document.initQry.submit();
   } else {
      alert("<%= m_noPromptMessage %>");
   }
}
</SCRIPT>
<INPUT TYPE=BUTTON CLASS=BUTTON VALUE="<%= m_newPromptLabel %>" OnClick="OnNewPrompt()">
<%
   if (m_valuesBean != null && "U".equalsIgnoreCase((String)request.getAttribute("typeValue"))) {
%>
<INPUT TYPE=BUTTON CLASS=BUTTON VALUE="<%= m_editPromptLabel %>" OnClick="OnEditPrompt()">
<INPUT TYPE=BUTTON CLASS=BUTTON VALUE="<%= m_deletePromptLabel %>" OnClick="OnDeletePrompt()">
<%
   }
%>
</TD></TR><TR><%
   } //end check for full query facility vs. stand-alone filtering
%>
<TD ALIGN=CENTER>
<%

   if (m_valuesBean != null || vals != null) {
      out.println("<INPUT TYPE=BUTTON CLASS=BUTTON VALUE="
               + bundle.getString("Common.OK.txt")
               + " OnClick=\"OnOK()\">");
   }
%>
<INPUT TYPE=BUTTON CLASS=BUTTON VALUE="<%= bundle.getString("Common.Cancel.txt") %>" OnClick="window.close();"></TD>
</TR>
</TABLE>
</FORM>
<!-- ---------- END NAV TOOL ---------- -->


</TD>
</TR>
</TABLE>

</TD></TR></TABLE> <!-- END WHOLE PAGE TABLE -->

</BODY>
</HTML>
